//=============================================================================
// MainDlg.cpp
//=============================================================================
#include "stdafx.h"
#include "Const.h."
#include "CSVString.h"
#include "BattleSysTester.h"
#include "MainDlg.h"
#include "afxdialogex.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMainDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	ZeroMemory( m_PlayerCharacterInfo, sizeof(m_PlayerCharacterInfo) );
	ZeroMemory( &m_PlayerPartyInfo, sizeof(m_PlayerPartyInfo) );
}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMainDlg::~CMainDlg()
{
	DeleteEnemyPartyInfo();
	DeleteFieldInfo();
}
//-----------------------------------------------------------------------------
// DeleteEnemyPartyInfo
//-----------------------------------------------------------------------------
void CMainDlg::DeleteEnemyPartyInfo( void )
{
	for ( int iCnt = 0; iCnt < m_arEnemyPartyInfo.GetCount(); iCnt ++ )
	{
		stEnemyPartyInfo *pInfo = m_arEnemyPartyInfo.GetAt( iCnt );
		delete pInfo;
	}

	m_arEnemyPartyInfo.RemoveAll();
}
//-----------------------------------------------------------------------------
// DeleteFieldInfo
//-----------------------------------------------------------------------------
void CMainDlg::DeleteFieldInfo( void )
{
	for ( int iCnt = 0; iCnt < m_arFieldInfo.GetCount(); iCnt ++ )
	{
		stFieldInfo *pInfo = m_arFieldInfo.GetAt( iCnt );
		delete pInfo;
	}

	m_arFieldInfo.RemoveAll();
}


//-----------------------------------------------------------------------------
// DoDataExchange
//-----------------------------------------------------------------------------
void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}
//-----------------------------------------------------------------------------
// bZ[W}bv
//-----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CMainDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CMD_SEND, &CMainDlg::OnBnClickedCmdSend)
	ON_BN_CLICKED(IDC_CMD_TABLE_LOAD, &CMainDlg::OnBnClickedCmdTableLoad)
	ON_BN_CLICKED(IDC_CMD_PLAYER_PARTY_SAVE, &CMainDlg::OnBnClickedCmdPlayerPartySave)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB_CHAR, &CMainDlg::OnTcnSelchangeTabChar)
	ON_BN_CLICKED(IDC_CMD_PLAYER_PARTY_LOAD, &CMainDlg::OnBnClickedCmdPlayerPartyLoad)
END_MESSAGE_MAP()


//-----------------------------------------------------------------------------
// OnInitDialog
//-----------------------------------------------------------------------------
BOOL CMainDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	// Rg[ݒ
	SetupControls();

	// e[uǂݍ
	LoadTables();

	// p[eBf[^ǂݍ
	LoadPlayerParty();


	return TRUE;
}
//-----------------------------------------------------------------------------
// SetupControls
//-----------------------------------------------------------------------------
void CMainDlg::SetupControls( void )
{
	// p[eBR{{bNX
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_PLAYER_PARTY_COUNT);

	pCombo->AddString( "1l" );
	pCombo->AddString( "2l" );
	pCombo->AddString( "3l" );
	pCombo->AddString( "4l" );
	pCombo->SetCurSel( 3 );


	// ^u̐ݒ
	CTabCtrl *pTabCtrl = (CTabCtrl*)GetDlgItem(IDC_TAB_CHAR);
	pTabCtrl->InsertItem( 0, "CHAR 1" );
	pTabCtrl->InsertItem( 1, "CHAR 2" );
	pTabCtrl->InsertItem( 2, "CHAR 3" );
	pTabCtrl->InsertItem( 3, "CHAR 4" );
	pTabCtrl->SetCurSel( 0 );
	if ( !m_wndTabChar.Create(CTabCharWnd::IDD, pTabCtrl) )
	{
		AfxMessageBox("m_wndTabChar.Create error");
		return;
	}
	CRect rctTabChild;
	pTabCtrl->GetClientRect( &rctTabChild );
    rctTabChild.left  += 4;
	rctTabChild.right -= 4;

	rctTabChild.top   += 20;
	rctTabChild.bottom -= 4;

    m_wndTabChar.MoveWindow( &rctTabChild, TRUE );
	m_wndTabChar.ShowWindow( SW_SHOW  );

	GetDlgItem(IDC_EDIT_GILL)->SetWindowText( "0" );
}

//-----------------------------------------------------------------------------
// OnPaint
//-----------------------------------------------------------------------------
void CMainDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//-----------------------------------------------------------------------------
// OnQueryDragIcon
//-----------------------------------------------------------------------------
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//-----------------------------------------------------------------------------
// OnBnClickedCmdSend
//-----------------------------------------------------------------------------
void CMainDlg::OnBnClickedCmdSend()
{

	// f[^擾
	CString csBuff;
	GetDlgItem(IDC_EDIT_GILL)->GetWindowText( csBuff );
	m_PlayerPartyInfo.nGill = atoi(csBuff);
	CComboBox *pComboPt = (CComboBox *)GetDlgItem(IDC_CMB_PLAYER_PARTY_COUNT);
	m_PlayerPartyInfo.nPlayerCount = pComboPt->GetCurSel() + 1;

	m_wndTabChar.GetData( m_PlayerCharacterInfo );

	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_FIELD);
	CComboBox *pComboEnemy = (CComboBox *)GetDlgItem(IDC_CMB_ENEMY_PARTY);

	// Mݒ
	stBattleParam BattleParam;

	// tB[h
	BattleParam.Field = *m_arFieldInfo.GetAt( pCombo->GetCurSel() );
	// Gp[eB
	BattleParam.Enemy = *m_arEnemyPartyInfo.GetAt( pComboEnemy->GetCurSel() );
	// ʏ
	BattleParam.Party = m_PlayerPartyInfo;
	// v[
	CopyMemory( BattleParam.Chara, m_PlayerCharacterInfo, sizeof(BattleParam.Chara) );


	COPYDATASTRUCT pcds;
	pcds.dwData = 100;
	pcds.cbData = sizeof(stBattleParam);
	pcds.lpData = &BattleParam;

	// M
	CWnd *pWnd = FindWindow( NULL, "proto01" );
	if ( pWnd )
	{
		pWnd->SendMessage( WM_COPYDATA, (WPARAM)AfxGetMainWnd()->GetSafeHwnd(), (LPARAM)&pcds );
		//pWnd->PostMessage( WM_USER + 100, 0, 0 );
	}
}

//-----------------------------------------------------------------------------
// e[u [Ǎ]{^
//-----------------------------------------------------------------------------
void CMainDlg::OnBnClickedCmdTableLoad()
{
	// e[uǂݍ
	LoadTables();
}
//-----------------------------------------------------------------------------
// LoadTables
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadTables( void )
{
	BOOL bRet = TRUE;
	bRet &= LoadFieldTable();
	bRet &= LoadEnemyTable();
	bRet &= LoadEnemyPartyTable();
	bRet &= LoadArrangeTable();
	bRet &= LoadCommandTable();

	return bRet;
}

//-----------------------------------------------------------------------------
// LoadFieldTable
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadFieldTable( void )
{
	CFileStatus sts;
	// FieldTable
	if ( !CFile::GetStatus( FIELD_TABLE_FILE_NAME, sts ) )
	{
		return FALSE;
	}

	// Xg폜
	DeleteFieldInfo();
	
	char szLine[32*1024];
	char wkBuff[1024];
	CStdioFile fileCSV;
	try
	{
		if ( !fileCSV.Open( FIELD_TABLE_FILE_NAME, CFile::modeRead  ) )
		{
			return FALSE;
		}

		// 1,2sڂ xs
		fileCSV.ReadString( szLine, sizeof(szLine) );
		fileCSV.ReadString( szLine, sizeof(szLine) );

		// 3sڂf[^
		while ( fileCSV.ReadString( szLine, sizeof(szLine) ) )
		{
			stFieldInfo *pInfo = new stFieldInfo;
			m_arFieldInfo.Add( pInfo );
			LPCSTR pPtr = szLine;
			
			// ID
			pInfo->nID = CCSVString::GetNextInt( pPtr );

			// O
			CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
			strcpy_s( pInfo->szName, wkBuff );
		}

		fileCSV.Close();
	}
	catch ( CFileException* e)
	{
		e->Delete();
		return FALSE;
	}

	// R{{bNXɒǉ
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_FIELD);
	pCombo->ResetContent();
	for ( int iCnt = 0; iCnt < m_arFieldInfo.GetCount(); iCnt ++ )
	{
		stFieldInfo *pInfo = m_arFieldInfo.GetAt( iCnt );
		CString csBuff;
		csBuff.Format( "%2d:%s",pInfo->nID, pInfo->szName );
		int nIndex = pCombo->AddString( csBuff );
		pCombo->SetItemData( nIndex, pInfo->nID );
	}
	pCombo->SetCurSel( 0 );

	return TRUE;
}
//-----------------------------------------------------------------------------
// LoadEnemyTable
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadEnemyTable( void )
{
	CFileStatus sts;
	// EnemyTable
	if ( !CFile::GetStatus( ENEMY_TABLE_FILE_NAME, sts ) )
	{
		GetDlgItem(IDC_LBL_ENEMY_TABLE_STS)->SetWindowText( STATUS_NOT_FOUND );
		return FALSE;
	}

	GetDlgItem(IDC_LBL_ENEMY_TABLE_STS)->SetWindowText( STATUS_EXIST );

	return TRUE;
}
//-----------------------------------------------------------------------------
// LoadEnemyPartyTable
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadEnemyPartyTable( void )
{
	CFileStatus sts;
	// EnemyPartyTable
	if ( !CFile::GetStatus( ENEMY_PARTY_TABLE_FILE_NAME, sts ) )
	{
		GetDlgItem(IDC_LBL_ENEMY_PARTY_TABLE_STS)->SetWindowText( STATUS_NOT_FOUND );
		return FALSE;
	}

	GetDlgItem(IDC_LBL_ENEMY_PARTY_TABLE_STS)->SetWindowText( STATUS_EXIST );

	// Xg폜
	DeleteEnemyPartyInfo();

	// Ǎ
	//ENEMY_PARTY_INFO

	char szLine[32*1024];
	char wkBuff[1024];
	CStdioFile fileCSV;
	try
	{
		if ( !fileCSV.Open( ENEMY_PARTY_TABLE_FILE_NAME, CFile::modeRead  ) )
		{
			GetDlgItem(IDC_LBL_ENEMY_PARTY_TABLE_STS)->SetWindowText( STATUS_EXIST );
			return FALSE;
		}

		// 1,2sڂ xs
		fileCSV.ReadString( szLine, sizeof(szLine) );
		fileCSV.ReadString( szLine, sizeof(szLine) );

		// 3sڂf[^
		while ( fileCSV.ReadString( szLine, sizeof(szLine) ) )
		{
			stEnemyPartyInfo *pInfo = new stEnemyPartyInfo;
			m_arEnemyPartyInfo.Add( pInfo );
			LPCSTR pPtr = szLine;

			// ID
			pInfo->nID = CCSVString::GetNextInt( pPtr );

			// O
			CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
			strcpy_s( pInfo->szName, _countof(pInfo->szName), wkBuff );

		}

		fileCSV.Close();
	}
	catch ( CFileException* e)
	{
		e->Delete();
		return FALSE;
	}

	// R{{bNXɒǉ
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_ENEMY_PARTY);
	pCombo->ResetContent();
	for ( int iCnt = 0; iCnt < m_arEnemyPartyInfo.GetCount(); iCnt ++ )
	{
		stEnemyPartyInfo *pInfo = m_arEnemyPartyInfo.GetAt( iCnt );
		CString csBuff;
		csBuff.Format( "%5d:%s",pInfo->nID, pInfo->szName );
		int nIndex = pCombo->AddString( csBuff );
		pCombo->SetItemData( nIndex, pInfo->nID );
	}
	pCombo->SetCurSel( 0 );

	return TRUE;
}

//-----------------------------------------------------------------------------
// LoadArrangeTable
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadArrangeTable( void )
{
	CFileStatus sts;
	// ArrangeTable
	if ( !CFile::GetStatus( ARRANGE_TABLE_FILE_NAME, sts ) )
	{
		GetDlgItem(IDC_LBL_ARRANGE_TABLE_STS)->SetWindowText( STATUS_NOT_FOUND );
		return FALSE;
	}

	GetDlgItem(IDC_LBL_ARRANGE_TABLE_STS)->SetWindowText( STATUS_EXIST );

	return TRUE;
}
//-----------------------------------------------------------------------------
// LoadCommandTable
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadCommandTable( void )
{
	CFileStatus sts;
	// CommandTable
	if ( !CFile::GetStatus( COMMAND_TABLE_FILE_NAME, sts ) )
	{
		GetDlgItem(IDC_LBL_COMMAND_TABLE_STS)->SetWindowText( STATUS_NOT_FOUND );
		return FALSE;
	}

	GetDlgItem(IDC_LBL_COMMAND_TABLE_STS)->SetWindowText( STATUS_EXIST );
	return TRUE;
}
//-----------------------------------------------------------------------------
// LoadPlayerParty
//-----------------------------------------------------------------------------
BOOL CMainDlg::LoadPlayerParty( void )
{
	return TRUE;
}

//-----------------------------------------------------------------------------
// [ۑ]
//-----------------------------------------------------------------------------
void CMainDlg::OnBnClickedCmdPlayerPartySave()
{
	const CString filter("CSV̧(*.csv)|*.csv|ׂẴt@C(*.*)|*.*|");
    CFileDialog dlg(FALSE, "csv", NULL, OFN_HIDEREADONLY|OFN_NOCHANGEDIR, filter);
	//dlg.m_ofn.lpstrInitialDir = csDirName;
	//dlg.m_ofn.lpstrFile = szFileName;
	if ( dlg.DoModal() != IDOK )
	{
		return;
	}

	// f[^擾
	CString csBuff;
	GetDlgItem(IDC_EDIT_GILL)->GetWindowText( csBuff );
	m_PlayerPartyInfo.nGill = atoi(csBuff);
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_PLAYER_PARTY_COUNT);
	m_PlayerPartyInfo.nPlayerCount = pCombo->GetCurSel() + 1;

	m_wndTabChar.GetData( m_PlayerCharacterInfo );

	// t@Cɕۑ
	CStdioFile fileOutput;
	if ( !fileOutput.Open( dlg.GetPathName(), CFile::modeCreate| CFile::modeWrite ) )
	{
		CString csBuff;
		csBuff.Format( "[%s]̏o͂Ɏs܂", dlg.GetPathName() );
		AfxMessageBox( csBuff );
		return;
	}

	CString csLine;

	// ʍڏo
	csLine.Format("%d,%d\n", m_PlayerPartyInfo.nPlayerCount, m_PlayerPartyInfo.nGill );
	fileOutput.WriteString(csLine);

	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{	// Lڏo
		stPlayerCharacterInfo *p = &m_PlayerCharacterInfo[iCnt];

		csLine.Format( "%d,%s, %d, %d, %d, %d, %d, %d, "
					   "%d, %d, %d, %d, %d, %d, %d, %d, "
					   "%d, %d, %d, %d, %d, %d, %d, %d, "
					   "%d, %d, %d, %d, %d, %d, %d\n",
						p->nID, p->szName, p->nLV, p->nJLV, p->nBtlPos, p->nExp, p->nHP, p->nMP,
						p->nATBValue, p->nAttack, p->nDefence, p->nMagicDef, p->nParry, p->nMagicPar, p->nWeight, p->nMaxHP,
						p->nMaxMP, p->nStrength, p->nVitality, p->nSpeed, p->nIntellect, p->nPiety, p->nLuck, p->bPoison,
						p->bFrog, p->bParalyze, p->bSmall, p->bStone, p->bBlind, p->bZombi, p->bSilence );

		fileOutput.WriteString(csLine);
		fileOutput.Flush();
	}

	fileOutput.Close();


}
//-----------------------------------------------------------------------------
// [Ǎ]
//-----------------------------------------------------------------------------
void CMainDlg::OnBnClickedCmdPlayerPartyLoad()
{
	// tH_擾
	const CString filter("CSV̧(*.csv)|*.csv|ׂẴt@C(*.*)|*.*|");
    CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_NOCHANGEDIR, filter);
	dlg.m_ofn.lpstrInitialDir = ".";

	if ( dlg.DoModal() != IDOK )
	{
		return;
	}

	CStdioFile fileCSV;
	if ( !fileCSV.Open( dlg.GetPathName(), CFile::modeRead ) )
	{
		CString csBuff;
		csBuff.Format( "[%s]̏o͂Ɏs܂", dlg.GetPathName() );
		AfxMessageBox( csBuff );
		return;
	}

	// ʍړǍ
	char szLine[1024];
	fileCSV.ReadString( szLine, sizeof(szLine) );
	LPCSTR pPtr = szLine;

	m_PlayerPartyInfo.nPlayerCount = CCSVString::GetNextInt( pPtr );
	m_PlayerPartyInfo.nGill = CCSVString::GetNextInt( pPtr );

	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		fileCSV.ReadString( szLine, sizeof(szLine) );
		pPtr = szLine;
		stPlayerCharacterInfo *p = &m_PlayerCharacterInfo[iCnt];

		p->nID = CCSVString::GetNextInt( pPtr );
		CCSVString::GetNextString(p->szName, sizeof(p->szName), pPtr );
		p->nLV = CCSVString::GetNextInt( pPtr );
		p->nJLV = CCSVString::GetNextInt( pPtr );
		p->nBtlPos = CCSVString::GetNextInt( pPtr );
		p->nExp = CCSVString::GetNextInt( pPtr );
		p->nHP = CCSVString::GetNextInt( pPtr );
		p->nMP = CCSVString::GetNextInt( pPtr );
		p->nATBValue = CCSVString::GetNextInt( pPtr );
		p->nAttack = CCSVString::GetNextInt( pPtr );
		p->nDefence = CCSVString::GetNextInt( pPtr );
		p->nMagicDef = CCSVString::GetNextInt( pPtr );
		p->nParry = CCSVString::GetNextInt( pPtr );
		p->nMagicPar = CCSVString::GetNextInt( pPtr );
		p->nWeight = CCSVString::GetNextInt( pPtr );
		p->nMaxHP = CCSVString::GetNextInt( pPtr );
		p->nMaxMP = CCSVString::GetNextInt( pPtr );
		p->nStrength = CCSVString::GetNextInt( pPtr );
		p->nVitality = CCSVString::GetNextInt( pPtr );
		p->nSpeed = CCSVString::GetNextInt( pPtr );
		p->nIntellect = CCSVString::GetNextInt( pPtr );
		p->nPiety = CCSVString::GetNextInt( pPtr );
		p->nLuck = CCSVString::GetNextInt( pPtr );
		p->bPoison = CCSVString::GetNextInt( pPtr );
		p->bFrog = CCSVString::GetNextInt( pPtr );
		p->bParalyze = CCSVString::GetNextInt( pPtr );
		p->bSmall = CCSVString::GetNextInt( pPtr );
		p->bStone = CCSVString::GetNextInt( pPtr );
		p->bBlind = CCSVString::GetNextInt( pPtr );
		p->bZombi = CCSVString::GetNextInt( pPtr );
		p->bSilence = CCSVString::GetNextInt( pPtr );
	}

	fileCSV.Close();

	// ʂɔf
	m_wndTabChar.SetData( m_PlayerCharacterInfo );
	CString csBuff;
	csBuff.Format( "%d", m_PlayerPartyInfo.nGill );
	GetDlgItem(IDC_EDIT_GILL)->SetWindowText( csBuff );


	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_PLAYER_PARTY_COUNT);
	pCombo->SetCurSel( m_PlayerPartyInfo.nPlayerCount - 1 );

}

//-----------------------------------------------------------------------------
// ^u`FW
//-----------------------------------------------------------------------------
void CMainDlg::OnTcnSelchangeTabChar(NMHDR *pNMHDR, LRESULT *pResult)
{
	CTabCtrl *pTabCtrl = (CTabCtrl*)GetDlgItem(IDC_TAB_CHAR);
	int iCurSel = pTabCtrl->GetCurSel();

	m_wndTabChar.NotifyTabChange( iCurSel );

	*pResult = 0;
}

