//=============================================================================
// MainDlg.h
//=============================================================================
#pragma once
#include "Const.h"
#include "TabCharWnd.h"
//-----------------------------------------------------------------------------
// CMainDlg
//-----------------------------------------------------------------------------
class CMainDlg : public CDialogEx
{
protected:
	stPlayerCharacterInfo	m_PlayerCharacterInfo[BATTLE_CHAR_COUNT_MAX];
	arEnemyPartyInfo	m_arEnemyPartyInfo;
	CTabCharWnd			m_wndTabChar;
	stPlayerPartyInfo	m_PlayerPartyInfo;
	arFieldInfo			m_arFieldInfo;

protected:
	BOOL LoadEnemyTable( void );
	BOOL LoadEnemyPartyTable( void );
	BOOL LoadArrangeTable( void );
	BOOL LoadCommandTable( void );
	BOOL LoadFieldTable( void );

	// e[u[h
	BOOL LoadTables( void );
	BOOL LoadPlayerParty( void );

	void SetupControls( void );
	void DeleteEnemyPartyInfo( void );
	void DeleteFieldInfo( void );

	void SetCell(CWnd *pWnd, CString csValue, int nRow, int nCol);
	CString GetItemText(CWnd *pWnd, int nItem, int nSubItem) const;

public:
	CMainDlg(CWnd* pParent = NULL);	// WRXgN^[
	virtual ~CMainDlg();

// _CAO f[^
	enum { IDD = IDD_BATTLESYSTESTER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedCmdSend();
	afx_msg void OnBnClickedCmdTableLoad();
	afx_msg void OnBnClickedCmdPlayerPartySave();
	afx_msg void OnTcnSelchangeTabChar(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedCmdPlayerPartyLoad();
};
