//=============================================================================
// TabCharWnd.cpp
//=============================================================================

#include "stdafx.h"
#include "BattleSysTester.h"
#include "TabCharWnd.h"
#include "afxdialogex.h"


IMPLEMENT_DYNAMIC(CTabCharWnd, CDialogEx)
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CTabCharWnd::CTabCharWnd(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTabCharWnd::IDD, pParent)
	, m_szName(_T("")), m_nTabCur( 0 )

{
	ZeroMemory( &m_stDispInfo, sizeof(m_stDispInfo) );
	ZeroMemory( m_stPartyInfo, sizeof(m_stPartyInfo) );
}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CTabCharWnd::~CTabCharWnd()
{
}
//-----------------------------------------------------------------------------
// DoDataExchange
//-----------------------------------------------------------------------------
void CTabCharWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_ID, m_stDispInfo.nID );
	DDX_Text(pDX, IDC_EDIT_NAME, m_szName);
	DDX_Text(pDX, IDC_EDIT_LV, m_stDispInfo.nLV);
	DDX_Text(pDX, IDC_EDIT_JLV, m_stDispInfo.nJLV);
	DDX_CBIndex(pDX, IDC_CMB_POS, m_stDispInfo.nBtlPos);
	DDX_Text(pDX, IDC_EDIT_EXP, m_stDispInfo.nExp);
	DDX_Text(pDX, IDC_EDIT_HP, m_stDispInfo.nHP);
	DDX_Text(pDX, IDC_EDIT_MAX_HP, m_stDispInfo.nMaxHP);
	DDX_Text(pDX, IDC_EDIT_MP, m_stDispInfo.nMP);
	DDX_Text(pDX, IDC_EDIT_MAX_MP, m_stDispInfo.nMaxMP);
	DDX_Text(pDX, IDC_EDIT_ATB_VALUE, m_stDispInfo.nATBValue);
	DDX_Check(pDX, IDC_CHK_POISON, m_stDispInfo.bPoison);
	DDX_Check(pDX, IDC_CHK_FROG, m_stDispInfo.bFrog);
	DDX_Check(pDX, IDC_CHK_PARALYZE, m_stDispInfo.bParalyze);
	DDX_Check(pDX, IDC_CHK_SMALL, m_stDispInfo.bSmall);
	DDX_Check(pDX, IDC_CHK_STONE, m_stDispInfo.bStone);
	DDX_Check(pDX, IDC_CHK_BLIND, m_stDispInfo.bBlind);
	DDX_Check(pDX, IDC_CHK_ZOMBI, m_stDispInfo.bZombi);
	DDX_Check(pDX, IDC_CHK_SILENCE, m_stDispInfo.bSilence);
	DDX_Text(pDX, IDC_EDIT_ATTACK, m_stDispInfo.nAttack);
	DDX_Text(pDX, IDC_EDIT_DEFENSE, m_stDispInfo.nDefence);
	DDX_Text(pDX, IDC_EDIT_MAGIC_DEFENSE, m_stDispInfo.nMagicDef);
	DDX_Text(pDX, IDC_EDIT_PARRY, m_stDispInfo.nParry);
	DDX_Text(pDX, IDC_EDIT_MAGIC_PARRY, m_stDispInfo.nMagicPar);
	DDX_Text(pDX, IDC_EDIT_WEIGHT, m_stDispInfo.nWeight);
	DDX_Text(pDX, IDC_EDIT_STRENGTH, m_stDispInfo.nStrength);
	DDX_Text(pDX, IDC_EDIT_VITALITY, m_stDispInfo.nVitality);
	DDX_Text(pDX, IDC_EDIT_SPEED, m_stDispInfo.nSpeed);
	DDX_Text(pDX, IDC_EDIT_INTELLECT, m_stDispInfo.nIntellect);
	DDX_Text(pDX, IDC_EDIT_PIETY, m_stDispInfo.nPiety);
	DDX_Text(pDX, IDC_EDIT_LUCK, m_stDispInfo.nLuck);
}
//-----------------------------------------------------------------------------
// bZ[W
//-----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CTabCharWnd, CDialogEx)
END_MESSAGE_MAP()

//-----------------------------------------------------------------------------
// OnInitDialog
//-----------------------------------------------------------------------------
BOOL CTabCharWnd::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// R{{bNXݒ
	CComboBox *pCombo = (CComboBox *)GetDlgItem(IDC_CMB_POS);

	pCombo->AddString( "Oq" );
	pCombo->AddString( "q" );

	pCombo->SetCurSel( 0 );
	//m_nPiety = 10;
	//UpdateData( FALSE );

	return TRUE;
}
//-----------------------------------------------------------------------------
// NotifyTabChange
//-----------------------------------------------------------------------------
void CTabCharWnd::NotifyTabChange( int nTabCur )
{
	// ʂf[^XV
	UpdateData( TRUE );
	strcpy_s( m_stDispInfo.szName, _countof(m_stDispInfo.szName),  m_szName );

	// ܂ŕ\Ă̂ۑ
	CopyMemory( &m_stPartyInfo[m_nTabCur], &m_stDispInfo, sizeof(m_stDispInfo) );

	// V^û\
	CopyMemory( &m_stDispInfo, &m_stPartyInfo[nTabCur], sizeof(m_stDispInfo) );
	m_szName = m_stDispInfo.szName;

	m_nTabCur = nTabCur;

	UpdateData( FALSE );

}

//-----------------------------------------------------------------------------
// GetData
//-----------------------------------------------------------------------------
void CTabCharWnd::GetData( stPlayerCharacterInfo *pInfo )
{
	// ʂf[^XV
	UpdateData( TRUE );
	strcpy_s( m_stDispInfo.szName, _countof(m_stDispInfo.szName),  m_szName );
	// \1Rs[
	CopyMemory( &m_stPartyInfo[m_nTabCur], &m_stDispInfo, sizeof(m_stDispInfo) );

	// 4ƂRs[
	CopyMemory( pInfo, m_stPartyInfo, sizeof(m_stPartyInfo) );
}

//-----------------------------------------------------------------------------
// SetData
//-----------------------------------------------------------------------------
void CTabCharWnd::SetData( stPlayerCharacterInfo *pInfo )
{
	// \1Rs[
	CopyMemory( &m_stDispInfo, &pInfo[m_nTabCur], sizeof(m_stDispInfo) );
	m_szName = m_stDispInfo.szName;

	// 4ƂRs[
	CopyMemory( m_stPartyInfo, pInfo, sizeof(m_stPartyInfo) );

	UpdateData( FALSE );
}