//=============================================================================
// BattleSystem.h
//=============================================================================
#pragma once
#include <list>

class CCommandManager;
class CField;
class CManipulator;
class CDisplayManager;
class CCharacter;
class CEnemy;

// [h
enum {
	MODE_INIT = 0,			// 
	MODE_BATTLE,			// ʏ
	MODE_WIN,				// I
	MODE_LOSE,				// I
};

//-----------------------------------------------------------------------------
// CBattleSystem
//-----------------------------------------------------------------------------
class CBattleSystem
{
private:
	CBattleSystem(void);
	virtual ~CBattleSystem(void);

protected:
	int				m_nMode;			// [h (/ʏ/I)
	CField			*m_pField;			// tB[hEn`
	CDisplayManager	*m_pDisplayMan;		// \}l[W
	CManipulator	*m_pManipulator;	// Ǘ
	
	CCommandManager *m_pCommandMan;		// R}hsǗ
	std::list<int>	m_lstAction;		// v[R}h͏Ǘ

	// v[p[eB[
	stPlayerPartyInfo	m_PartyParam;
	CCharacter	*m_pPlayerChar[BATTLE_CHAR_COUNT_MAX];

	// Gp[eB[
	int		m_nEnemyCount;
	CEnemy	*m_pEnemy[BATTLE_ENEMY_COUNT_MAX];

	DWORD	m_dwSystemFrameCount;

	void HaltBattle( void );							// 퓬I

	// v[p[eB̐ݒ
	void SetupPlayerParty( const stPlayerPartyInfo *pPartyInfo, const stPlayerCharacterInfo *pCharaInfo );
	void SetupEnemy( const stEnemyPartyInfo *pEnemy );

	int CalcDamage( int nCommandID, int nParam1, int nParam2 );

public:
	static CBattleSystem *GetInstance( void );

	BOOL Initialize( void );	// 
	void FrameMove( void );		// XV
	void Render( void );		// `
	void CommandProc( void );	// R}h

	BOOL StartBattle( const stBattleParam *pParam );	// 퓬Jn

	// 퓬p[^ݒ
	BOOL SetupBattleParam( const stBattleParam *pParam );

	// t[JE^l擾
	DWORD GetSystemFrameCount( void ) const
	{	return m_dwSystemFrameCount;	};

	// [h̎擾
	int GetMode( void ) const
	{	return m_nMode;	};

	// R}ho^
	void AddCommand( int nCommandID, int nParam1, int nParam2 );

	//  R}h͑҂Xg
	// o^
	void AddActionablePlayer( int nIndex );

	// 擾
	int GetActionablePlayer( void )
	{
		if ( m_lstAction.empty() )
			return -1;	// o^Ȃ

		int nIndex = m_lstAction.front();
		m_lstAction.pop_front();

		return nIndex;
	}

	// Debug
	void Debug_SetupPartyInfo( stPlayerPartyInfo *pPartyInfo, stPlayerCharacterInfo *pCharaInfo );

};
