//=============================================================================
// Character.cpp
//=============================================================================
#include "Stdinc.h"
#include "Character.h"
const char *PLAYER_FILE_NAME[] = 
{
	PLAYER_FILE_NAME_01,PLAYER_FILE_NAME_02,
	PLAYER_FILE_NAME_03,PLAYER_FILE_NAME_04,
};


//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CCharacter::CCharacter(void)
	:m_nDispPicPtrn( STAND ), m_nAnimationPtrn(ANI_PTN_NONE), m_dwFrameCount( 0 )
{
	ZeroMemory( &m_Param, sizeof(m_Param) );
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CCharacter::~CCharacter(void)
{
	// 摜̉
	Finalize();
}
//-----------------------------------------------------------------------------
// LoadGraph
// 摜f[^Ǎ
//-----------------------------------------------------------------------------
BOOL CCharacter::LoadGraph( void )
{
	m_lpzFileName = PLAYER_FILE_NAME[m_Param.nID-1];
	// wiGǂݍ
	int iRet = LoadDivGraph( m_lpzFileName , CHAR_CHIP_COUNT, CHAR_CHIP_COUNT, 1, 27, 27, m_nHandle ) ;
	if ( iRet != DX_SUCCESS )
	{
		CUtility::tERROR("摜ǂݍݎs [%s]", m_lpzFileName );
		return FALSE;
	}
	return TRUE;
}
//-----------------------------------------------------------------------------
// Finalize
// I
//-----------------------------------------------------------------------------
void CCharacter::Finalize( void )
{
	for ( int iCnt = 0; iCnt < CHAR_CHIP_COUNT; iCnt ++ )
	{
		DeleteGraph( m_nHandle[iCnt] );
	}
}

//-----------------------------------------------------------------------------
// SetName
//-----------------------------------------------------------------------------
void CCharacter::SetName( const char *pName )
{
	strncpy_s( m_Param.szName, pName, _countof(m_Param.szName)-1 );
}
//-----------------------------------------------------------------------------
// StartAnimation
// Aj[Vp^[ݒ
//-----------------------------------------------------------------------------
void CCharacter::StartAnimation( int nPaternNo )
{
	m_nAnimationPtrn = nPaternNo;

	// Aj[VX^[gʒuݒ
	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_WALK_AT_START:	// Jns
		m_nDispPosX = m_nPosX + 50;
		break;
	default:
		// {ʒuɖ߂
		m_nDispPosX = m_nPosX;
		m_nDispPosY = m_nPosY;
	}

	// t[JE^Zbg
	m_dwFrameCount = 0;

}
//-----------------------------------------------------------------------------
// FrameMove
// XV
//-----------------------------------------------------------------------------
void CCharacter::FrameMove( void )
{
	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_NONE:			// Aj[V
		m_nDispPicPtrn = STAND;
		break;

	case ANI_PTN_WALK_AT_START:	// Jns
		if ( m_dwFrameCount % 6  < 3 )
		{
			m_nDispPicPtrn = WALK_R;
			m_nDispPosX -= 2;
		}
		else
		{
			m_nDispPosX -= 2;
			m_nDispPicPtrn = STAND;
		}

		if ( m_dwFrameCount == 25 )
		{
			StartAnimation( ANI_PTN_NONE );
		}
		break;

	case ANI_PTN_ATTACK:			// U

		if ( m_dwFrameCount <= 20 )
		{	// 20t[Oɕ
			if ( m_dwFrameCount % 6  < 3 )
			{
				m_nDispPicPtrn = WALK_R;
				m_nDispPosX -= 1;
			}
			else
			{
				m_nDispPosX -= 1;
				m_nDispPicPtrn = STAND;
			}
		}
		else if ( m_dwFrameCount <= 40 )
		{	// 20t[U[V
			if ( m_dwFrameCount % 4  < 2 )
			{
				m_nDispPicPtrn = ATACK_01;
			}
			else
			{
				m_nDispPicPtrn = ATACK_02;
			}
		}
		else if ( m_dwFrameCount <= 60 )
		{	// 20t[ジ
			if ( m_dwFrameCount % 6  < 3 )
			{
				m_nDispPicPtrn = WALK_R;
				m_nDispPosX += 1;
			}
			else
			{
				m_nDispPosX += 1;
				m_nDispPicPtrn = STAND;
			}
		}
		else
		{
			StartAnimation( ANI_PTN_NONE );
		}
		break;
	}

	// ATBl
	IncreaseATBValue( m_dwFrameCount );

	m_dwFrameCount ++;
}

//-----------------------------------------------------------------------------
// GetAnimationFrameToHpChange
// ̍
//-----------------------------------------------------------------------------
int CCharacter::GetAnimationFrameToHpChange( int nPaternNo )
{
	if ( nPaternNo == ANI_PTN_ATTACK )
		return 40;

	return 0;
}

//-----------------------------------------------------------------------------
// Render
// _O
//-----------------------------------------------------------------------------
void CCharacter::Render( void )
{
	// g`
	DrawGraph( m_nDispPosX, m_nDispPosY, m_nHandle[m_nDispPicPtrn], TRUE );
}
//-----------------------------------------------------------------------------
// IncreaseATBValue
// ATBl
//-----------------------------------------------------------------------------
void CCharacter::IncreaseATBValue( DWORD dwFrameCount )
{
	if ( dwFrameCount % 5 == 1 )
	{
		// Xe[^Xɉ ATBlXV
		if ( m_Param.nATBValue < ATB_VALUE_MAX )
		{
			++ m_Param.nATBValue;
		}
		else
		{
			m_Param.nATBValue = ATB_VALUE_MAX;
		}
	}
}
