//=============================================================================
// Enemy.cpp
//=============================================================================
#include "Stdinc.h"
#include "Enemy.h"
#include "NumberAnimation.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CEnemy::CEnemy(void)
	:m_pNumAnime( NULL )
{
	// lAj[V
	m_pNumAnime = new CNumberAnimation();
}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CEnemy::~CEnemy(void)
{
	Finalize();

	
	if ( m_pNumAnime )
	{
		delete m_pNumAnime;
	}
}

//-----------------------------------------------------------------------------
// Initialize
// 
//-----------------------------------------------------------------------------
BOOL CEnemy::LoadGraph( void )
{
	char szFileName[MAX_PATH];

	sprintf_s( szFileName, sizeof(szFileName), "%s\\enemy_%03d.png", GRAPHICS_DIR_03, m_Param.nID );

	// wiGǂݍ
	m_nHandle = ::LoadGraph( szFileName );
	if ( m_nHandle == DX_FAILED )
	{
		CUtility::tERROR("摜ǂݍݎs [%s]", szFileName );
		return FALSE;
	}
	GetGraphSize( m_nHandle, &m_nGraphWidth, &m_nGraphHeight );

	return TRUE;
}
//-----------------------------------------------------------------------------
// Finalize
// I
//-----------------------------------------------------------------------------
void CEnemy::Finalize( void )
{
	DeleteGraph( m_nHandle );
}
//-----------------------------------------------------------------------------
// FrameMove
// XV
//-----------------------------------------------------------------------------
void CEnemy::FrameMove( void )
{

	m_pNumAnime->FrameMove();

}
//-----------------------------------------------------------------------------
// Render
// _O
//-----------------------------------------------------------------------------
void CEnemy::Render( void )
{
	// g`
	DrawGraph( m_nPosX, m_nPosY, m_nHandle, TRUE );

	// HPAj[V
	m_pNumAnime->Render();
}
//-----------------------------------------------------------------------------
// GetCursorDispPos
// J[\\ʒu擾
//-----------------------------------------------------------------------------
void CEnemy::GetCursorDispPos( int *pX, int *pY )
{
	*pX = m_nPosX - 8;
	*pY = m_nPosY + (m_nGraphHeight / 2) - 8;
}
//-----------------------------------------------------------------------------
// GetNumAnimeDispPos
// Aj[V\ʒu擾
//-----------------------------------------------------------------------------
void CEnemy::GetNumAnimeDispPos( int *pX, int *pY, int iDispWidth )
{
	*pX = m_nPosX + ((m_nGraphWidth+iDispWidth) / 2);
	*pY = m_nPosY + m_nGraphHeight - 12;
}
//-----------------------------------------------------------------------------
// ChangeHitPoint
// HP
//-----------------------------------------------------------------------------
void CEnemy::ChangeHitPoint( int iDiff, int nWaitFrame )
{
	// HPAj[Vݒ
	DWORD dwColor;
	if ( 0 <= iDiff )
	{	// 0Ɛ̒l
		dwColor = GetColor(255,255,255);
	}
	else
	{	// ̒l(HP)
		dwColor = GetColor(96,255,96);
	}

	int iX,iY;
	int iWidth = CNumberAnimation::GetDispWidth( iDiff );
	GetNumAnimeDispPos( &iX, &iY, iWidth );
	m_pNumAnime->StartAnimation( iX, iY, iDiff, dwColor, nWaitFrame );

	// HP炷
	m_nHP -= iDiff;
	if ( m_nHP < 0 )
		m_nHP = 0;
}
