//=============================================================================
// TableAccess.cpp
//=============================================================================
#include "Stdinc.h"
#include "TableAccess.h"
#include "CSVString.h"
#include "Enemy.h"
//-----------------------------------------------------------------------------
// LoadEnemyPartyTable
//-----------------------------------------------------------------------------
BOOL CTableAccess::LoadEnemyPartyTable( int nEnemyPartyID, CEnemy **pEnemy, int *pEnemyCount )
{
	char szLine[32*1024];
	char wkBuff[1024];
	FILE *fp;


	//  EnemyPartyTable.csv
	if ( fopen_s( &fp, ENEMY_PARTY_TABLE_FILE_NAME, "r" ) != 0 )
	{
		CUtility::tERROR("t@Cǂݍݎs [%s]", ENEMY_PARTY_TABLE_FILE_NAME);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	stEnemyPartyTable EnemyPartyData;
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;
		
		EnemyPartyData.nID = CCSVString::GetNextInt( pPtr );
		if ( nEnemyPartyID != EnemyPartyData.nID )
		{	// ID
			continue;
		}

		// O
		CCSVString::GetNextString( wkBuff, sizeof(wkBuff), pPtr );
		strcpy_s( EnemyPartyData.szName, wkBuff );

		// X^[
		EnemyPartyData.nEnemyCount = CCSVString::GetNextInt( pPtr );

		// zup^[ID
		EnemyPartyData.nArrangePtnID = CCSVString::GetNextInt( pPtr );

		// X^[ID
		for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
		{
			EnemyPartyData.nEnemyID[iCnt] = CCSVString::GetNextInt( pPtr );
		}
		// ꏈtO
		EnemyPartyData.nFlag1 = CCSVString::GetNextInt( pPtr );
		// ꏈp^
		EnemyPartyData.nParam1 = CCSVString::GetNextInt( pPtr );
		// ꏈtO2
		EnemyPartyData.nFlag2 = CCSVString::GetNextInt( pPtr );
		// ꏈp^2
		EnemyPartyData.nParam2 = CCSVString::GetNextInt( pPtr );

		break;	// ̂ŌȂ
	}

	fclose( fp );


	
	//  ArrangeTable.csv
	if ( fopen_s( &fp, ARRANGE_TABLE_FILE_NAME, "r" ) != 0 )
	{
		CUtility::tERROR("t@Cǂݍݎs [%s]", ARRANGE_TABLE_FILE_NAME);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	stArrangeTable ArrangeData;
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		LPCSTR pPtr = szLine;
		
		ArrangeData.nID = CCSVString::GetNextInt( pPtr );
		if ( ArrangeData.nID  != EnemyPartyData.nArrangePtnID )
		{	// ID
			continue;
		}
		// X^[
		ArrangeData.nEnemyCount = CCSVString::GetNextInt( pPtr );

		// X^[ʒu
		for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
		{
			ArrangeData.Pos[iCnt].nX = CCSVString::GetNextInt( pPtr );
			ArrangeData.Pos[iCnt].nY = CCSVString::GetNextInt( pPtr );
		}
		break;	// ̂ŌȂ
	}
	fclose( fp );


	
	//  EnemyTable.csv
	if ( fopen_s( &fp, ENEMY_TABLE_FILE_NAME, "r" ) != 0 )
	{
		CUtility::tERROR("t@Cǂݍݎs [%s]", ENEMY_TABLE_FILE_NAME);
		return FALSE;
	}
	// 1,2sڂ xs
	fgets( szLine, sizeof(szLine), fp );
	fgets( szLine, sizeof(szLine), fp );

	// 3sڂf[^
	stEnemyInfo EnemyData;
	int nEnemyCount = 0;
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		for ( int iCnt = 0; iCnt < BATTLE_ENEMY_COUNT_MAX; iCnt ++ )
		{	// Gp[eB[f[^ɂ邩
			LPCSTR pPtr = szLine;
			// ID
			EnemyData.nID = CCSVString::GetNextInt( pPtr );
			if ( EnemyData.nID == EnemyPartyData.nEnemyID[iCnt] )
			{
				if ( pEnemy[nEnemyCount] )
					delete pEnemy[nEnemyCount];

				pEnemy[nEnemyCount] = new CEnemy();

				// ʒu
				pEnemy[nEnemyCount]->SetDispPos(ArrangeData.Pos[iCnt].nX, ArrangeData.Pos[iCnt].nY);

				// ID
				pEnemy[nEnemyCount]->m_Param.nID = EnemyData.nID;
				// O
				CCSVString::GetNextString( pEnemy[nEnemyCount]->m_Param.szName, sizeof(pEnemy[nEnemyCount]->m_Param.szName), pPtr );

				// ݂̃x
				pEnemy[nEnemyCount]->m_Param.nLV = CCSVString::GetNextInt( pPtr ); 

				// MaxHP
				pEnemy[nEnemyCount]->m_Param.nMaxHP = CCSVString::GetNextInt( pPtr ); 
				pEnemy[nEnemyCount]->m_nHP = pEnemy[nEnemyCount]->m_Param.nMaxHP;

				// MaxMP
				pEnemy[nEnemyCount]->m_Param.nMaxMP = CCSVString::GetNextInt( pPtr ); 
				pEnemy[nEnemyCount]->m_nMP = pEnemy[nEnemyCount]->m_Param.nMaxMP;

				// ATBl
				pEnemy[nEnemyCount]->m_Param.nATBValue = CCSVString::GetNextInt( pPtr ); 

				// U
				pEnemy[nEnemyCount]->m_Param.nAttack = CCSVString::GetNextInt( pPtr ); 

				// h
				pEnemy[nEnemyCount]->m_Param.nDefence = CCSVString::GetNextInt( pPtr ); 

				// @h
				pEnemy[nEnemyCount]->m_Param.nMagicDef = CCSVString::GetNextInt( pPtr ); 

				// 
				pEnemy[nEnemyCount]->m_Param.nParry = CCSVString::GetNextInt( pPtr ); 

				// @
				pEnemy[nEnemyCount]->m_Param.nMagicPar = CCSVString::GetNextInt( pPtr ); 

				// 
				pEnemy[nEnemyCount]->m_Param.nStrength = CCSVString::GetNextInt( pPtr ); 
  
				// ̗
				pEnemy[nEnemyCount]->m_Param.nVitality = CCSVString::GetNextInt( pPtr ); 

				// f
				pEnemy[nEnemyCount]->m_Param.nSpeed = CCSVString::GetNextInt( pPtr ); 

				// 
				pEnemy[nEnemyCount]->m_Param.nIntellect = CCSVString::GetNextInt( pPtr ); 

				// _
				pEnemy[nEnemyCount]->m_Param.nPiety = CCSVString::GetNextInt( pPtr ); 

				// ^
				pEnemy[nEnemyCount]->m_Param.nLuck = CCSVString::GetNextInt( pPtr ); 

				// LM
				pEnemy[nEnemyCount]->m_Param.nGill = CCSVString::GetNextInt( pPtr ); 

				// o
				pEnemy[nEnemyCount]->m_Param.nExp = CCSVString::GetNextInt( pPtr ); 

				// R}h
				for ( int iCnt = 0; iCnt < 5; iCnt ++ )
				{
					pEnemy[nEnemyCount]->m_Param.nCommand[iCnt] = CCSVString::GetNextInt( pPtr ); 
				}

				// ACe
				for ( int iCnt = 0; iCnt < 4; iCnt ++ )
				{
					pEnemy[nEnemyCount]->m_Param.nItem[iCnt] = CCSVString::GetNextInt( pPtr ); 
				}

				// OtBbN[h
				pEnemy[nEnemyCount]->LoadGraph();

				nEnemyCount ++;
			}
		}

		if ( EnemyPartyData.nEnemyCount <= nEnemyCount )
		{	// ̂ŌȂ
			break;
		}
	}
	fclose( fp );

	*pEnemyCount = nEnemyCount;

	return TRUE;
}
//-----------------------------------------------------------------------------
// LoadDefaultPlayerPartyTable
//-----------------------------------------------------------------------------
BOOL CTableAccess::LoadDefaultPlayerPartyTable( stPlayerPartyInfo *pPartyInfo, stPlayerCharacterInfo *pCharaInfo )
{
	char szLine[32*1024];
	FILE *fp;

	//  EnemyPartyTable.csv
	if ( fopen_s( &fp, DEFAULT_PLAYER_PARTY_CSV_FILE, "r" ) != 0 )
	{
		CUtility::tERROR("t@Cǂݍݎs [%s]", DEFAULT_PLAYER_PARTY_CSV_FILE);
		return FALSE;
	}

	// 1sڂ̓p[eB
	fgets( szLine, sizeof(szLine), fp );
	LPCSTR pPtr = szLine;
	pPartyInfo->nPlayerCount = CCSVString::GetNextInt( pPtr );
	pPartyInfo->nGill = CCSVString::GetNextInt( pPtr );

	// ȍ~L
	int iCnt = 0;
	while ( fgets( szLine, sizeof(szLine), fp ) )
	{
		pPtr = szLine;
		stPlayerCharacterInfo *p = &pCharaInfo[iCnt];

		p->nID = CCSVString::GetNextInt( pPtr );
		CCSVString::GetNextString(p->szName, sizeof(p->szName), pPtr );
		p->nLV = CCSVString::GetNextInt( pPtr );
		p->nJLV = CCSVString::GetNextInt( pPtr );
		p->nBtlPos = CCSVString::GetNextInt( pPtr );
		p->nExp = CCSVString::GetNextInt( pPtr );
		p->nHP = CCSVString::GetNextInt( pPtr );
		p->nMP = CCSVString::GetNextInt( pPtr );
		p->nATBValue = CCSVString::GetNextInt( pPtr );
		p->nAttack = CCSVString::GetNextInt( pPtr );
		p->nDefence = CCSVString::GetNextInt( pPtr );
		p->nMagicDef = CCSVString::GetNextInt( pPtr );
		p->nParry = CCSVString::GetNextInt( pPtr );
		p->nMagicPar = CCSVString::GetNextInt( pPtr );
		p->nWeight = CCSVString::GetNextInt( pPtr );
		p->nMaxHP = CCSVString::GetNextInt( pPtr );
		p->nMaxMP = CCSVString::GetNextInt( pPtr );
		p->nStrength = CCSVString::GetNextInt( pPtr );
		p->nVitality = CCSVString::GetNextInt( pPtr );
		p->nSpeed = CCSVString::GetNextInt( pPtr );
		p->nIntellect = CCSVString::GetNextInt( pPtr );
		p->nPiety = CCSVString::GetNextInt( pPtr );
		p->nLuck = CCSVString::GetNextInt( pPtr );
		p->bPoison = CCSVString::GetNextInt( pPtr );
		p->bFrog = CCSVString::GetNextInt( pPtr );
		p->bParalyze = CCSVString::GetNextInt( pPtr );
		p->bSmall = CCSVString::GetNextInt( pPtr );
		p->bStone = CCSVString::GetNextInt( pPtr );
		p->bBlind = CCSVString::GetNextInt( pPtr );
		p->bZombi = CCSVString::GetNextInt( pPtr );
		p->bSilence = CCSVString::GetNextInt( pPtr );

		iCnt ++;

	}

	fclose( fp );

	return TRUE;
}
